/**
 * Created by marven on 2016/4/11.
 */
(function(){
    "use strict";
    var NiceCheck=function(index,element,option){
        this.index=index;
        this.target=element;
        this.settings=option;
        this.init();
    };
    NiceCheck.prototype.init=function(){
        var NC=this;
        var ele=this.target;
        var settings=this.settings;
        var index=this.index;
        var _id=$(ele).attr("id");
        if(_id=="undefined"||_id==null||_id==""){

            _id="nice-check-"+settings.idSuffix+"-"+index;
            $(ele).attr("id","nice-check-"+settings.idSuffix+"-"+index);
        }
        var _label=$("<label class='nc-label'></label>");
        //жǷǽ״̬
        if($(ele).is(":disabled")){
            _label.addClass("disabled");
        }
        /**
         * Ҫӵѡйܣ
         */
        if(settings.hasText){
            var _text=$(ele).next("span.nc-label-text").text();
            _label.css(settings.textStyle).text(_text);
            $(ele).next("span.nc-label-text").remove();
        }
        /**
         * ݵѡѡclass
         */
        if(settings.type=="checkbox"){
            _label.addClass("nc-label-checkbox");
        }else{
            _label.addClass("nc-label-radio");
            //ǵѡҪΪռ飬ͨnameԵֵ
            _label.attr("data-name",$(ele).attr("name"));
        }
        if($(ele).is(":checked")){
            _label.addClass("checked");
        }
        _label.attr("for",_id);
        //󶨵¼ʵѡкͲѡелЧ
        _label.on("click",{settings:settings},NC.labelClick);
        //labelռӵҳ
        _label.insertAfter($(ele));
        //ԭʼؼ
        $(ele).addClass("nc-input");
    };
    NiceCheck.prototype.update= function () {
        var _id=this.target.id;
        if($("#"+_id).is(":checked")){
            $("label[for="+_id+"]").addClass("checked");
        }else{
            $("label[for="+_id+"]").removeClass("checked");
        }

    };
    NiceCheck.prototype.destroy= function () {
        var _id=this.target.id;
        $("#"+_id).removeClass("nc-input").next(".nc-label").remove();
    };
    NiceCheck.prototype.labelClick=function(e){
        var eve=e||event;
        var ele=eve.target;
        var settings= e.data.settings;
        var targetInputId=$(ele).attr("for");
        if($(ele).is(".disabled")){
            eve.preventDefault();
            return;
        }else {
            /**
             * ǵѡťѡеǰѡѡnameͬ
             */
            if (settings.type == "radio") {
                var _name = $(ele).attr("data-name");
                $(".nc-label-radio[data-name=" + _name + "]").removeClass("checked");
                $(ele).addClass("checked");
            }
            //Ǹѡֱѡлѡ
            else {
                if ($(ele).is(".checked")) {
                    $(ele).removeClass("checked")
                } else {
                    $(ele).addClass("checked");
                }
            }
            //Ⱦҳ棬Ӧĵѡѡťĵ¼
        }
    };
    /**
     * 󶨲
     */
    $.fn.niceCheck=function(option){
        var defaults={
            type:"checkbox",
            hasText:false,
            textStyle:{},
            idSuffix:new Date().getTime()
        };
        var settings=null;
        if("update"==option||"destroy"==option){
            settings=defaults;
        }else{
            settings= $.extend({},defaults,option);
        }

        $(this).each(function(index,ele){
            if("update"==option){
                var NC=$(ele).data("NiceCheck");
                NC.update();
            }else if("destroy"==option){
                var NC=$(ele).data("NiceCheck");
                NC.destroy();
            }else{
                $(ele).data("NiceCheck",new NiceCheck(index,ele,settings));
            }

        })
    }
})();
